(*
 simple graphical tasks using
 the BGI
declare:
 USES
  graph, strings, crt;
*)

FUNCTION findBGIPATH:string;
 var
  i	:integer;
  rval	:string;
 begin
  rval := '';
  for i:=1 to paramcount do
   begin
    if pos('/BGI:', upStr(paramstr(i))) <> 0
     then begin
      rval := paramstr(i);
      rval := upStr(copy(rval, 6, length(rval)));
     end;
   end;
  findBGIPATH := rval;
 end;

FUNCTION modeVGAHI(path:string):boolean;
 var
  grDriver: Integer;
  grMode: Integer;
  ErrCode: Integer;
 begin
  grDriver := Detect;
  InitGraph(grDriver, grMode, path);
  if(graphResult <> grOK) then
  	begin
    modeVGAHI := false;
    exit;
    end;
  setTextStyle(SMALLFONT, HORIZDIR, 4);
  setTextJustify(LEFTTEXT, BOTTOMTEXT);
  modevgahi := true;
 end;

PROCEDURE waitRetrace; assembler;
 label
  l1, l2;
 asm
  mov dx,3DAh
  l1:
   in al,dx
   and al,08h
   jnz l1
  l2:
   in al,dx
   and al,08h
   jz  l2
 end;

PROCEDURE graphCls(c:integer);
 begin
  if c > transparent
    then setFillStyle(SOLIDFILL, c);
  bar(0, 0, getMaxX, getMaxY);
 end;

PROCEDURE wipe(x1, y1, x2, y2:integer;bc, fs:integer);
 begin
  setFillStyle(fs, bc);
  bar(x1, y1, x2, y2);
 end;

PROCEDURE box(x1, y1, x2, y2:integer;bc, fc, fs:integer);
 begin
  if bc>transparent
   then begin
    setFillStyle(fs, bc);
    bar(x1, y1, x2, y2);
   end;
  setColor(fc);
  rectangle(x1, y1, x2, y2);
 end;

PROCEDURE screen(title:string;x1,y1,x2,y2,bcolor,fcolor,fs:integer);
 begin
  box(x1, y1, x2, y2, bcolor, fcolor, fs);
  setFillStyle(SOLIDFILL ,lightgray);
  bar(x1 ,y1 ,x2 ,y1+20);
  setColor(fcolor);
  rectangle(x1 ,y1 ,x2 ,y1+20);
  setTextJustify(CENTERTEXT ,CENTERTEXT);
  setColor(black);
  setTextStyle(0, HORIZDIR, 1);
  outTextXY(x1 +(x2-x1) div 2 ,y1 +10 ,title);
 end;

PROCEDURE printXY(x,y,bc,tc:integer;s:string);
 begin
  SetTextJustify(LeftText,TopText);
  setFillStyle(SOLIDFILL, bc);
  bar(x, y+2, x+textWidth(s), y+textHeight(s));
  Setcolor(tc);
  OutTextXY(x,y,s);
 end;

PROCEDURE tildeTextXY(x,y,tc,hc:integer;s:string);
 var
  i, l, b	:integer;
 begin
  l := length(s);
  for i:=1 to l do
   begin
    if s[i] = '~'
     then begin
      setColor(hc);
      inc(i);
     end
     else setColor(tc);
    outTextXY(x, y, s[i]);
    inc(x, textWidth(s[i]));
   end;
 end;


PROCEDURE inputXY(x,y,bc,tc:integer;var s:string);
 var
  l	:byte;
  key1	:char;
 begin
  SetTextJustify(LeftText,TopText);
  wipe(x,y,TextWidth(s+'m'),TextHeight(s),bc,SOLIDFILL);
  Setcolor(tc);
  OutTextXY(x,y,s);
  repeat
   repeat
   until keypressed;
   key1 := readKey;
   l:=length(s);
   case key1 of
    #32..#126	: {alphanum} s:=s+key1;
    #8		: {backspace}s:=copy(s,1,l-1);
   end;
   wipe(x,y,TextWidth(s+'M'),TextHeight('M'),bc, SOLIDFILL);
   Setcolor(tc);
   OutTextXY(x,y,s);
  until key1=#32;
 end;

FUNCTION sInput(s:string;v:string;d:byte;getval:boolean):string;
{
 String Eingabefunktion mit "preset".
 if not getval : nur textausgabe, ohne user abfrage (whrend aufbau einer dialogseite o..)
}
 var
  rval	:string;
  p, l	:byte;
  x, y	:integer;
  cx, cy:integer;
  c1, c2:char;
 begin
  if length(v) > d
    then v := copy(v, 1, d);
  rval := v;
  setColor(colorset.tc);
  outText(s+ ' : ');
  x := getX;
  y := getY;
  wipe(x, y, x+textWidth(rval+'Mg'), y-textHeight(rval+'Mg'), colorset.bc, SOLIDFILL);
  setColor(colorset.hc);
  outText(rval);
  p := length(rval);
  if getval
   then repeat
    moveTo(x, y);
    wipe(x, y, x+textWidth(rval+'Mg'), y-textHeight(rval+'Mg'), colorset.bc, SOLIDFILL);
    setColor(colorset.hc);
    outText(rval);
    cx := getX;
    cy := getY;
    moveTo(x+textWidth(copy(rval, 1, p)), y);
    setColor(colorset.cc);
    line(getX, y, getX, y-textHeight('M'));
    setColor(colorset.bc);
    l := length(rval);
    getKeys(c1, c2);
    if (c2=#0) and (c1 in [#0..#7, #9, #11..#12, #14..#31, #32..#255]) {printable characters}
      then begin
       inc(p);
       insert(c1, rval, p);
      end;
    if (c1=#8) and (p>=1) {backspace}
     then begin
      rval := (copy(rval, 1, p-1)+copy(rval, p+1, l-p));
      dec(p);
     end;
    if (c2=#75) and (p>=1) {cursor to left}
      then dec(p);
    if (c2=#77) and (p<l) {cursor to right}
      then inc(p);
    if (c2=#71) {home}
      then p := 0;
    if (c2=#79) {end}
      then p := l;
    if (c2=#83) and (p<=l) {delete}
      then rval := (copy(rval, 1, p)+copy(rval, p+2, l-p));
    if length(rval) > d	{now test size...}
      then begin
       rval := copy(rval, 1, d);
       p := d;
      end;
    if (c1=#13)
      then break;
   until false;
  moveTo(x, y);
  wipe(x, y, x+textWidth(rval+'Mg'), y-textHeight(rval+'Mg'), colorset.bc, SOLIDFILL);
  setColor(colorset.hc);
  outText(rval);
  sInput := rval;
 end;


FUNCTION rInput(s:string;v:real;d:byte;getval:boolean):real;
{
 Numerische real Eingabefunktion mit "preset".
 Siehe auch strInput.
}
 var
  st	:string;
  rval	:real;
  test	:integer;
  x, y	:integer;
 begin
  setColor(colorset.tc);
  outText(s);
  setColor(colorset.hc);
  rval := v;
  x := getX;
  y := getY;
  wipe(x, y, x+textWidth(s+' : '+strOf_(rval)+'Mg'), y-textHeight(s+' : '+strOf_(rval)+'Mg'), colorset.bc, SOLIDFILL);
  outText(' : '+ strOf_(rval));
  if getval
    then repeat
     test := 0;
     moveTo(x, y{-1});
     st := sInput('', strOf_(rval), d, true);
     if pos(',', st) <> 0
       then st[pos(',', st)] := '.';
     if st = ''
       then rval := v
       else val(st, rval, test);
    until test = 0;
  wipe(x, y, x+textWidth(s+' : '+strOf_(rval)+'Mg'), y-textHeight(s+' : '+strOf_(rval)+'Mg'), colorset.bc, SOLIDFILL);
  moveTo(x, y{-1});
  setColor(colorset.tc);
  outText(' : ');
  setColor(colorset.hc);
  outText(strOf_(rval));
  setColor(colorset.bc);
  rInput := rval;
 end;
