UNIT param;

{
routines to handle commandline inputs
and debug/error/abort procedures
}

(*
 Apr.1999 by Frederik Arbeiter	<Frederik.Arbeiter@gmx.net>
 This program if free software as defined in the General Public License (GPL)
 published by the Free Software Foundation (FSF)
*)

INTERFACE

USES
 strings, dos;

PROCEDURE debugStr(s:string);
PROCEDURE debugNum(name:string;x:real);
PROCEDURE alert(s:string);
PROCEDURE abort(n:word;s:string);
FUNCTION posParam(s:string):integer;
FUNCTION getParam(s:string):string;
FUNCTION getNextCFG(var f:text):string;
FUNCTION testProgname(s:string):boolean;

IMPLEMENTATION

VAR
 _programname_	:string;

{$I vgabios.inc}

PROCEDURE debugStr(s:string);
 begin
  messageLn('DEBUG('+_programname_+') '+s+' ');
 end;

PROCEDURE debugNum(name:string;x:real);
 begin
  messageLn('DEBUG('+_programname_+') '+name+'='+strOf_(x));
 end;

PROCEDURE alert(s:string);
 begin
  messageLn('ALERT('+_programname_+') '+s);
 end;

PROCEDURE errorLn(s:string);
begin
 messageLn(s);
end;

PROCEDURE abort(n:word;s:string);
 begin
  messageLn('ABORT('+_programname_+','+strOfint(n)+') '+' '+s);
  halt(n);
 end;

FUNCTION posParam(s:string):integer;
 var
  i	:integer;
  rval	:integer;
 begin
  rval := 0;
  for i:=1 to paramcount do
   if pos(upStr(s), upStr(paramStr(i))) <> 0
     then rval := i;
  posParam := rval;
 end;

FUNCTION getParam(s:string):string;
 var
  i, p		:integer;
  rval, pS	:string;
 begin
  rval := '';
  s := upStr(s);
  p := posParam(s);
  if p > 0
   then begin
   pS := upStr(paramStr(p));
   {rval := getItem(upStr(paramStr(p)), 1, upStr(s));}
   rval := copy(pS, pos(s, pS)+length(s), length(pS)-(pos(s, pS)+length(s)-1));
   if rval[1] in [':', '='] then
   	rval := copy(rval, 2, length(rval)-1);
   end;
 getParam := rval;
 end;

FUNCTION getNextCFG(var f:text):string;
var
 s			:string;
begin
	repeat
    readLn(f, s);
    until s[1] <> '#';
getNextCFG := s;
end;

FUNCTION testProgname(s:string):boolean;
 begin
  testProgname := (pos(s, paramstr(0)) <> 0 );
 end;

BEGIN
 _programname_ := upStr(paramstr(0));
END.